function logBeta = ComputeBeta(MP, Inputs)

[C,S,N] = size(MP.WI_local);
D = size(MP.WI_obs, 2);
T = size(Inputs, 1);

%expW_pairwise_perm = permute(exp(MP.W(MP.WI_pairwise)), [2 1 3]); % CxCxS
W_pairwise_perm = permute(MP.W(MP.WI_pairwise), [2 1 3]); % CxCxS
%expW_pairwise = exp(MP.W(MP.WI_pairwise)); % CxCxS
%expW_local = exp(MP.W(MP.WI_local)); % CxSxN
W_obs = MP.W(MP.WI_obs); % CxD

logBeta = zeros(C,S,N,T);
logBeta(:,:,N,:) = 0; % log(1 ./ C ./ S);
%Beta(:,:,N,:) = bsxfun(@times, Beta(:,:,N,:), prod(Scaling(1,:,2:N,:), 3));

%Scaling = zeros(1,1,N,T);
%Scaling(1,1,N,:) = sum(sum(Beta(:,:,N,:), 1), 2);

Fi_obs = ones(T,D); % TxD
for i=N-1:-1:1
  % Update obs features. Assumes D=3 (1,x,x^2).
  Fi_obs(:,2) = Inputs(:,i+1);
  Fi_obs(:,3) = Fi_obs(:,2) .* Fi_obs(:,2);

  %expW_obs_times_Xi = exp(W_obs * Fi_obs'); % CxT = CxD * DxT
%   for t=1:T
%     expW_obs_times_x = expW_obs_times_X(:,t); % Cx1 = CxD * Dx1
% 
%     for c=1:C
%       for s=1:S
%         %acc = 0;
%         %for cj=1:C
%         %  acc = acc + Beta(cj,s,i+1,t) .* exp(...
%         %      MP.W(MP.WI_pairwise(c,cj,s)) ./ N + ...
%         %      MP.W(MP.WI_local(cj,s,i+1)) + ...
%         %      MP.W(MP.WI_obs(cj,:)) * (Inputs(t,i+1) .^ [0:D-1]') ...
%         %  );
%         %end
%         %Beta(c,s,i,t) = acc;
%         Beta(c,s,i,t) = sum(Beta(:,s,i+1,t) .* ...
%               expW_pairwise_perm(:,c,s) .* ...
%               expW_local(:,s,i+1) .* ...
%               expW_obs_times_x);
%       end
%     end
%   end
    
    %bsxfun(@rdivide, ...
  logBeta(:,:,i,:) = ... % CxSx1xT
      logsum(... % CxSxC*xT
        bsxfun(@plus, ...
          bsxfun(@plus, permute(logBeta(:,:,i+1,:), [3 2 1 4]), ... 1xSxC*xT
                        permute(W_obs * Fi_obs', [3 4 1 2])), ... % CxT 1x1 C*xT
          bsxfun(@plus, permute(W_pairwise_perm, [2 3 1 4]), ... % CxCxS Cx1x1 C*xCxS
                        permute(MP.W(MP.WI_local(:,:,i+1)), [3 2 1 4])) ... % CxSxN Cx1x1 C*xSx1
        ), 3); %, ...
      %Scaling(1,:,i+1,:));
  %Scaling(1,1,i,:) = sum(sum(Beta(:,:,i,:), 1), 2);
  %Scaling(1,:,i,:) = 1;
  %Beta(:,:,i,:) = bsxfun(@rdivide, Beta(:,:,i,:), Scaling(1,1,i,:));

end
return
